import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class SnakeHead here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SnakeHead extends Actor
{
    int Direction = 0;
    int ID=1;
    int score=0;
    int delay=0;
    String Key = "n";
    public boolean canEat()
    {
        Actor food = getOneObjectAtOffset(0, 0, Food.class);
        Actor object = getOneObjectAtOffset(0, 0, Object.class);
        return food !=null;
    }
    
    public boolean bitTail()
    {
        Actor food = getOneObjectAtOffset(0, 0, SnakeBody.class);
        return food !=null;
    }
    
    public boolean atWorldEdge()
    {
        if(getX() == 0 || getX() == getWorld().getWidth()-1)
            return true;
        if(getY() == 0 || getY() == getWorld().getHeight()-1)
            return true;
        else
            return false;
    }
    
    public void act() 
    {
        eat();
        Worldy worldy = (Worldy) getWorld();
        getKey();
        if(Key=="left"&&(Direction==1||Direction==3)&&delay==0)
        {
            setRotation(180);
            Direction=2;
            worldy.Direction=2;
            Key="n";
        }else if(Key=="right"&&(Direction==1||Direction==3)&&delay==0)
        {
            setRotation(0);
            Direction=0;
            worldy.Direction=0;
            Key="n";
        }else if(Key=="up"&&(Direction==0||Direction==2)&&delay==0)
        {
            setRotation(270);
            Direction=3;
            worldy.Direction=3;
            Key="n";
        }else if(Key=="down"&&(Direction==0||Direction==2)&&delay==0)
        {
            setRotation(90);
            Direction=1;
            worldy.Direction=1;
            Key="n";
        }
        move(1);
        if(delay<14)
        {
            delay++;
        }else{
            delay=0;
            worldy.addBody(ID);
        }
        //worldy.addBody(ID);
        if(atWorldEdge())
        {
            worldy.addObject(new GameOver("Game Over", score), worldy.getWidth()/2, worldy.getHeight()/2);
            worldy.removeObject(this);
            Greenfoot.playSound("sad-trombone.wav");
        }else if(bitTail()){
            worldy.addObject(new GameOver("CANABILISM!", score, "You should visit a therapist"), worldy.getWidth()/2, worldy.getHeight()/2);
            worldy.removeObject(this);
            Greenfoot.playSound("au.wav");
        }
    }
    
    public void getKey()
    {
        if(Greenfoot.isKeyDown("left"))
        {
            Key="left";
        }else if(Greenfoot.isKeyDown("right"))
        {
            Key="right";
        }else if(Greenfoot.isKeyDown("up"))
        {
            Key="up";
        }else if(Greenfoot.isKeyDown("down"))
        {
            Key="down";
        }
    }
    
    public void eat()
    {
        if(canEat())
        {
            Greenfoot.playSound("yeah.wav");
            Worldy world = (Worldy) getWorld();
            world.score(5);
            score++;
            world.addFood();
            world.addObject();
            ID++;
            Actor food = getOneObjectAtOffset(0, 0, Food.class);
            world.removeObject(food);
        }
    }
}
