import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Worldy here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worldy extends World
{
    public Counter counter;
    public SnakeHead snakehead;
    public SnakeBody snakebody;
    public int Direction = 0;
    public int b = 15;
    int level = 0;
    /**
     * Constructor for objects of class Worldy.
     * 
     */
    public Worldy()
    {
        super(29*15, 29*15, 1);
        prepare();
        setPaintOrder(Splash.class, StartButton.class, GameOver.class, SnakeHead.class, SnakeBody.class, Food.class, Counter.class);
    }
    
    private void prepare()
    {
        removeObjects(getObjects(null));
        if(level==0)
        {
            Splash splash = new Splash();
            addObject(splash, 14*b+7, 11*b+7);
            StartButton sB = new StartButton();
            addObject(sB, 14*b+7, 14*b+7);
            addFood();
            addFood();
            addFood();
            addFood();
            addFood();
            addFood();
        }
        if(level==1)
        {
            counter = new Counter();
            addObject(counter, 14*b+7, 1*b+7);
            addFood();
            snakehead = new SnakeHead();
            addObject(snakehead, 14*b+7, 14*b+7);
            addBody(1);
            addObject();
        }
    }
    
    public void addBody(int ID)
    {
        snakebody = new SnakeBody(ID);
        addObject(snakebody, snakehead.getX(), snakehead.getY());
        if(Direction == 0)
        {
            snakebody.move(-b);
        }
        if(Direction == 1)
        {
            snakebody.setRotation(90);
            snakebody.move(-b);
        }
        if(Direction == 2)
        {
            snakebody.setRotation(180);
            snakebody.move(-b);
        }
        if(Direction == 3)
        {
            snakebody.setRotation(270);
            snakebody.move(-b);
        }
        snakebody.direction=Direction;
        ++ID;
    }
    
    public void addFood()
    {
        addObject(new Food(), (Greenfoot.getRandomNumber(27)+1)*b+7, (Greenfoot.getRandomNumber(27)+1)*b+7);
    }
     
    public void addObject()
    {
         addObject(new Object(), (Greenfoot.getRandomNumber(27)+1)*b+7, (Greenfoot.getRandomNumber(27)+1)*b+7);counter.add(10);
        }
        
    public void score(int S)
    {
        counter.add(S);
    }
    
    public void NextLevel()
    {
        level++;
        prepare();
        Greenfoot.delay(300);
    }
}
